#!/usr/bin/env python
#-*- coding:utf-8 -*-

# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html

# The plugin requires 2 script-fu to be installed:
# 1. Export Sequential_processing.scm by Rob Antonishen http://gimpchat.com/viewtopic.php?f=9&t=4846&start=0&hilit=Sequential_processing
# 2. Guides-to-selection-mk2.scm by SteveMi http://gimpchat.com/viewtopic.php?f=9&t=14565&hilit=guides+to+selection&start=20#p201330

from gimpfu import *

def margins(image, drawable,steps):

	pdb.script_fu_guides_to_selection_mk2(image, drawable, 0)	
	pdb.gimp_selection_grow(image, steps)
	pdb.script_fu_selection_rounded_rectangle(image, drawable, 0, 0)
	pdb.gimp_selection_invert(image)
	pdb.gimp_drawable_edit_clear(drawable)
	pdb.plug_in_autocrop(image, drawable)
	pdb.gimp_displays_flush()
	pdb.seq_open_next_file(image, drawable)	

register(
	"python-fu-margins",
	"Selection from guides with extra margin, crop and saving,\nand opening the next file.\n          Open the first image with:\nFile/Export Sequential/1. Open the first file",
	"Selection from guides with extra margin, trimming and saving, and opening the next file.",
	"lmbgimp/MrQ",
	"GPL3",
	"2022",
	"Margins...",
	"*",
	[
		(PF_IMAGE,    "image", "takes current image", None),
		(PF_DRAWABLE, "drawable", "Input layer", None),
		(PF_SPINNER,  "steps", "Add Margin (px):", 50, (1, 1000, 1))
	],
	[],
	margins, menu="<Image>/Select")

main()    

